'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _getComponentModuleJSCode = require('./getComponentModuleJSCode');

var _getComponentModuleJSCode2 = _interopRequireDefault(_getComponentModuleJSCode);

var _getDocFile = require('./getDocFile');

var _getDocFile2 = _interopRequireDefault(_getDocFile);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var stateDoc = function () {
	function stateDoc() {
		(0, _classCallCheck3.default)(this, stateDoc);

		this.file = '';
		this.docComponent = {};
		this.sourceComponent = '';
		this.docMixins = [];
	}

	(0, _createClass3.default)(stateDoc, [{
		key: 'isMainComponent',
		value: function isMainComponent(file) {
			return file === this.file;
		}
	}, {
		key: 'saveComponent',
		value: function saveComponent(source, file) {
			if (this.isMainComponent(file) && this.sourceComponent !== source) {
				var jscodeReqest = (0, _getComponentModuleJSCode2.default)(source, file);
				var doc = (0, _getDocFile2.default)(jscodeReqest, file);
				this.docComponent = doc;
			}
		}
	}, {
		key: 'isMixin',
		value: function isMixin(doc) {
			return doc.some(function (docPart) {
				return docPart.kind === 'mixin';
			});
		}
	}, {
		key: 'getDoc',
		value: function getDoc() {
			var docMixins = [].concat.apply([], this.docMixins).filter(function (docPart) {
				return docPart.kind !== 'package';
			});
			return docMixins.concat(this.docComponent);
		}
	}, {
		key: 'saveMixin',
		value: function saveMixin(source, file) {
			var doc = (0, _getDocFile2.default)(source, file);
			if (this.isMixin(doc)) {

				doc = doc.map(function (docPart) {
					var longnameSplit = docPart.longname.split('.');
					if (longnameSplit[0] === 'default') {
						longnameSplit[0] = 'module.exports';
					}
					docPart.longname = longnameSplit.join('.');
					return docPart;
				}).filter(function (docPart) {
					return docPart.longname !== 'module.exports';
				});
				var index = void 0;
				this.docMixins.forEach(function (docMixin, id) {
					var packages = docMixin.filter(function (docPart) {
						return docPart.kind === 'package';
					})[0];
					if (packages && packages.files[0] === file) {
						index = id;
					}
				});
				if (index) {
					this.docMixins[index] = doc;
				} else {
					this.docMixins.push(doc);
				}
			}
		}
	}]);
	return stateDoc;
}();

exports.default = new stateDoc();